--- ../../old/cdr/cdr_pgsql.c	2007-06-20 13:41:57.000000000 -0600
+++ cdr_pgsql.c	2007-06-20 13:43:38.000000000 -0600
@@ -311,8 +311,14 @@
 
 static int reload(void)
 {
+	int res = 0;
+	
+	ast_mutex_lock(&pgsql_lock);
 	my_unload_module();
-	return my_load_module();
+	res = my_load_module();
+	ast_mutex_unlock(&pgsql_lock);
+	
+	return res;
 }
 
 AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_DEFAULT, "PostgreSQL CDR Backend",
